"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
order.proto

Functions and messages supporting an e-commerce
workflow for things like invoices, shipping labels,
etc.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import kerfed.protos.common.v1.address_pb2
import kerfed.protos.common.v1.config_pb2
import kerfed.protos.common.v1.fab_pb2
import kerfed.protos.common.v1.fileblob_pb2
import kerfed.protos.common.v1.money_pb2
import kerfed.protos.common.v1.price_pb2
import kerfed.protos.common.v1.scene_pb2
import kerfed.protos.common.v1.shipping_pb2
import kerfed.protos.common.v1.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _OrderEvent:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _OrderEventEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_OrderEvent.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    ORDER_EVENT_UNSPECIFIED: _OrderEvent.ValueType  # 0
    ORDER_EVENT_CREATED: _OrderEvent.ValueType  # 1
    ORDER_EVENT_SHARED: _OrderEvent.ValueType  # 2

class OrderEvent(_OrderEvent, metaclass=_OrderEventEnumTypeWrapper):
    """An enum for all the fabrication methods implemented
    corresponding to their field name on `PartFabrication`
    """

ORDER_EVENT_UNSPECIFIED: OrderEvent.ValueType  # 0
ORDER_EVENT_CREATED: OrderEvent.ValueType  # 1
ORDER_EVENT_SHARED: OrderEvent.ValueType  # 2
global___OrderEvent = OrderEvent

@typing_extensions.final
class Order(google.protobuf.message.Message):
    """The data structure that represents both an editable "quote," and
    a frozen "placed order."
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ORDER_ID_FIELD_NUMBER: builtins.int
    ACCOUNT_ID_FIELD_NUMBER: builtins.int
    SHOP_ID_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    PARTS_FIELD_NUMBER: builtins.int
    LINES_FIELD_NUMBER: builtins.int
    MODELS_FIELD_NUMBER: builtins.int
    SHIPPING_FIELD_NUMBER: builtins.int
    BILLING_FIELD_NUMBER: builtins.int
    PARCELS_FIELD_NUMBER: builtins.int
    TOTAL_FIELD_NUMBER: builtins.int
    DATE_MODIFIED_FIELD_NUMBER: builtins.int
    DATE_CREATED_FIELD_NUMBER: builtins.int
    order_id: builtins.str
    """The unique identifier for this specific order."""
    account_id: builtins.str
    """The unique identifier for the user placing the order"""
    shop_id: builtins.str
    """The unique identifier of the shop this order is associated with."""
    @property
    def state(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___OrderEventLog]:
        """Records events such as "placed," "emailed," "shared," etc."""
    @property
    def parts(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fab_pb2.PartFabrication]:
        """The extracted parts for this order."""
    @property
    def lines(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___OrderLine]:
        """A list of configured line items to order."""
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.scene_pb2.Scene]:
        """The models for the source files of the parts.
        This includes both a neutral format model and the
        original CAD data the scene was loaded from.
        """
    @property
    def shipping(self) -> kerfed.protos.common.v1.address_pb2.PostalAddress:
        """where is order shipped to"""
    @property
    def billing(self) -> kerfed.protos.common.v1.address_pb2.PostalAddress:
        """where is order billed to"""
    @property
    def parcels(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.shipping_pb2.ShippingParcel]:
        """the parcels this order is shipping with"""
    @property
    def total(self) -> kerfed.protos.common.v1.price_pb2.OrderPrice:
        """The total price including shipping."""
    @property
    def date_modified(self) -> kerfed.protos.common.v1.timestamp_pb2.Timestamp:
        """What was the last time this order was modified."""
    @property
    def date_created(self) -> kerfed.protos.common.v1.timestamp_pb2.Timestamp:
        """When was the order created."""
    def __init__(
        self,
        *,
        order_id: builtins.str = ...,
        account_id: builtins.str = ...,
        shop_id: builtins.str = ...,
        state: collections.abc.Iterable[global___OrderEventLog] | None = ...,
        parts: collections.abc.Iterable[kerfed.protos.common.v1.fab_pb2.PartFabrication] | None = ...,
        lines: collections.abc.Iterable[global___OrderLine] | None = ...,
        models: collections.abc.Iterable[kerfed.protos.common.v1.scene_pb2.Scene] | None = ...,
        shipping: kerfed.protos.common.v1.address_pb2.PostalAddress | None = ...,
        billing: kerfed.protos.common.v1.address_pb2.PostalAddress | None = ...,
        parcels: collections.abc.Iterable[kerfed.protos.common.v1.shipping_pb2.ShippingParcel] | None = ...,
        total: kerfed.protos.common.v1.price_pb2.OrderPrice | None = ...,
        date_modified: kerfed.protos.common.v1.timestamp_pb2.Timestamp | None = ...,
        date_created: kerfed.protos.common.v1.timestamp_pb2.Timestamp | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["billing", b"billing", "date_created", b"date_created", "date_modified", b"date_modified", "shipping", b"shipping", "total", b"total"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["account_id", b"account_id", "billing", b"billing", "date_created", b"date_created", "date_modified", b"date_modified", "lines", b"lines", "models", b"models", "order_id", b"order_id", "parcels", b"parcels", "parts", b"parts", "shipping", b"shipping", "shop_id", b"shop_id", "state", b"state", "total", b"total"]) -> None: ...

global___Order = Order

@typing_extensions.final
class OrderEventLog(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    TIME_FIELD_NUMBER: builtins.int
    EVENT_FIELD_NUMBER: builtins.int
    @property
    def time(self) -> kerfed.protos.common.v1.timestamp_pb2.Timestamp:
        """when did this event occur?"""
    event: global___OrderEvent.ValueType
    """What type of event was this?"""
    def __init__(
        self,
        *,
        time: kerfed.protos.common.v1.timestamp_pb2.Timestamp | None = ...,
        event: global___OrderEvent.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["time", b"time"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["event", b"event", "time", b"time"]) -> None: ...

global___OrderEventLog = OrderEventLog

@typing_extensions.final
class OrderLine(google.protobuf.message.Message):
    """The fully specified and priced lines of an order."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    LINE_ID_FIELD_NUMBER: builtins.int
    CONFIG_FIELD_NUMBER: builtins.int
    PRICE_FIELD_NUMBER: builtins.int
    line_id: builtins.str
    """A unique identifier for this line item which will be
    used to reference, modify, or delete this order part.
    """
    @property
    def config(self) -> kerfed.protos.common.v1.config_pb2.PartConfiguration:
        """The configuration used to generate the price."""
    @property
    def price(self) -> kerfed.protos.common.v1.price_pb2.LinePrice:
        """The calculated price for this line item."""
    def __init__(
        self,
        *,
        line_id: builtins.str = ...,
        config: kerfed.protos.common.v1.config_pb2.PartConfiguration | None = ...,
        price: kerfed.protos.common.v1.price_pb2.LinePrice | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["config", b"config", "price", b"price"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["config", b"config", "line_id", b"line_id", "price", b"price"]) -> None: ...

global___OrderLine = OrderLine

@typing_extensions.final
class Job(google.protobuf.message.Message):
    """a Job is a released-to-manufacture package"""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    SHOP_ID_FIELD_NUMBER: builtins.int
    ORDER_ID_FIELD_NUMBER: builtins.int
    JOB_ID_FIELD_NUMBER: builtins.int
    PART_ID_FIELD_NUMBER: builtins.int
    AMOUNT_FIELD_NUMBER: builtins.int
    SUMMARY_FIELD_NUMBER: builtins.int
    FILES_FIELD_NUMBER: builtins.int
    PARCELS_FIELD_NUMBER: builtins.int
    shop_id: builtins.str
    """which shop is making this"""
    order_id: builtins.str
    """which order was this job created from"""
    job_id: builtins.str
    """unique identifier for this job"""
    @property
    def part_id(self) -> google.protobuf.internal.containers.RepeatedScalarFieldContainer[builtins.str]:
        """the parts being manufactured by this job"""
    @property
    def amount(self) -> kerfed.protos.common.v1.money_pb2.Money:
        """the total amount of money that
        will be disbursed to the shop on completion
        shipping which will be either paid by us or
        invoiced separately.
        """
    @property
    def summary(self) -> kerfed.protos.common.v1.fileblob_pb2.FileBlob:
        """A PDF document with quantities, drawings
        shipping labels, etc.
        """
    @property
    def files(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.fileblob_pb2.FileBlob]:
        """any additional reference files, including
        flattened DXF drawings, original models, etc.
        """
    @property
    def parcels(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[kerfed.protos.common.v1.shipping_pb2.ShippingParcel]:
        """the parcels this order is shipping with"""
    def __init__(
        self,
        *,
        shop_id: builtins.str = ...,
        order_id: builtins.str = ...,
        job_id: builtins.str = ...,
        part_id: collections.abc.Iterable[builtins.str] | None = ...,
        amount: kerfed.protos.common.v1.money_pb2.Money | None = ...,
        summary: kerfed.protos.common.v1.fileblob_pb2.FileBlob | None = ...,
        files: collections.abc.Iterable[kerfed.protos.common.v1.fileblob_pb2.FileBlob] | None = ...,
        parcels: collections.abc.Iterable[kerfed.protos.common.v1.shipping_pb2.ShippingParcel] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["amount", b"amount", "summary", b"summary"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["amount", b"amount", "files", b"files", "job_id", b"job_id", "order_id", b"order_id", "parcels", b"parcels", "part_id", b"part_id", "shop_id", b"shop_id", "summary", b"summary"]) -> None: ...

global___Job = Job
